# Convert 256-bit double-glyph supporting font back to 128-bit format. Used
# to create \fonts\128bits\unifont\light.fnt, which I like quite a lot.


open(BIN,"<unifont.bin")||die;
binmode(BIN);
open(OUT,">unifont.old")||die;
$/=\32;
while(<BIN>)
{
    $a = unpack("a16a16",$_);
    #$a = substr($_, 0, 16);
    #$b = substr($_, 16);
    if ($b !~ m/^\0*$/)     # Interleaved
    {
        $i = 0; $a = join("", map { (++$i & 1) ? $_ : () } split //, $_); 
        $i = 0; $b = join("", map { (++$i & 1) ? () : $_ } split //, $_);
        # 16x16 not supported in old format, what to do? Use middle?
        # A[nd]d together?
        print OUT $a;
    } else {
        print OUT $a;       # Not interleaved
    }
    ++$ch;
    last if $ch >= 0xFF;
}
