DECLARE FUNCTION unutf$ (s$)
DECLARE SUB setavailable ()
DECLARE FUNCTION ucharf$ (index!, font$)
DECLARE FUNCTION uchar$ (index!)
DECLARE FUNCTION loadedat! (index!)
DECLARE SUB volta ()
DECLARE FUNCTION forlater$ (wchar$)
DECLARE FUNCTION getcode! (wchar$)
DECLARE SUB die (s$)
DECLARE FUNCTION utf2scalar! (utf$)
DECLARE FUNCTION fornow$ (wchar$)
DECLARE FUNCTION shr! (num!, bits!)
DECLARE FUNCTION shl! (num!, bits!)
DECLARE FUNCTION LNOT! (c!)
DECLARE FUNCTION scalar2utf$ (c!)
DECLARE FUNCTION newchar! (data$)
DECLARE FUNCTION reverse$ (s$)
DECLARE FUNCTION todec! (b$)
DECLARE FUNCTION tobin$ (n!)
DECLARE SUB setchar (ch!, data$)
DECLARE FUNCTION getstdchars$ ()
DECLARE SUB setchars (ch!, count!, data$)
' Created: 01-09-01
' By Jeff Connelly

' Copyright (C) 2001 Jeff Connelly

DIM SHARED fontfile

fontfile = FREEFILE
OPEN "fonts\unifont\unifont.bin" FOR BINARY AS #fontfile

DIM SHARED slots(255)           ' Characters 0-255; set to -1 if free for use
setavailable

'SHELL "volta"
SHELL "ascii"

'OPEN "unicode.txt" FOR INPUT AS #2
'd$ = INPUT$(LOF(2), 2)
'CLOSE 2
'PRINT unutf$(d$)

' E = mc^2
sup2$ = uchar$(&HB2)
PRINT "E = mc^2",
PRINT "E = mc" + sup2$

' H2O
PRINT "H2O",
sub2$ = uchar$(&H2082)
PRINT "H" + sub2$ + "O"

' c = a^(7-n)
PRINT "c = a^(7-n)",
supn$ = uchar$(&H207F)
supopen$ = uchar$(&H207D)
supclos$ = uchar$(&H207E)
sup7$ = uchar$(&H2077)
supminus$ = uchar$(&H207B)
PRINT "c = a" + supopen$ + sup7$ + supminus$ + supn$ + supclos$

euro$ = uchar$(&H20AC)
PRINT "Balance:7euro", "Balance: 7" + euro$, "1" + uchar$(&H2030) + " increase"

yingyang$ = uchar$(&H25D3)
PRINT "Ying-yang: ", yingyang$ + " has a code of" + STR$(getcode(yingyang$))

fourtwo$ = ucharf$(&H42, "Hex")
PRINT "4/2", fourtwo$

' Multi-glyph
cjk$ = uchar$(&H8000&) + uchar$(&H8001&) + uchar$(&H8042&) + uchar$(&H80FE&)
PRINT "CJK: ", cjk$

PRINT "Copyleft (C) 2001. All Rights Reserved.",
copyright$ = uchar$(&HA9)
' Copyleft (C) 2001. All Rights Reserved.
PRINT "Copyleft " + copyright$ + " 2001. All Rights Reversed.";
'PRINT forlater$(copyright$)     ' print to file

index = &H21
any$ = uchar$(index)
PRINT "Use arrow keys or / to change, Esc to exit: " + CHR$(0)
DO
    k$ = INKEY$
    SELECT CASE k$
    CASE "":
    CASE CHR$(0) + "K": index = ABS(index - 1): any$ = uchar$(index)
    CASE CHR$(0) + "M": index = index + 1: any$ = uchar$(index)
    CASE "/": LOCATE 20, 40: INPUT "char?", index$
              index = VAL("&H" + index$)
              any$ = uchar$(index)
    CASE ELSE: EXIT DO
    END SELECT
    LOCATE 23, 50: PRINT any$ + " ";
    H$ = HEX$(index)
    H$ = STRING$(ABS(2 - LEN(H$)), "0") + H$
    LOCATE 23, 55: PRINT H$;

LOOP

'PRINT "Use arrow keys to repeated value, Esc to exit: " + CHR$(0)
'PRINT STRING$(80 * 25, CHR$(0))
'glyph = &HAA
'DO
'    k$ = INKEY$
'    SELECT CASE k$
'    CASE "":
'    CASE CHR$(0) + "K": glyph = glyph - 1: setchar 0, STRING$(16, glyph)
'    CASE CHR$(0) + "M": glyph = glyph + 1: setchar 0, STRING$(16, glyph)
'    CASE CHR$(27): EXIT DO
'    END SELECT
'    LOCATE 22, 50: PRINT HEX$(glyph);
'LOOP

volta
SHELL "ascii"

SYSTEM











'utf$ = scalar2utf$(&H2B5)
'PRINT "UTF: ", utf$, HEX$(utf2scalar(utf$))
'END



'FOR i = 7128 TO 255
'    FOR j = 1 TO 64
'        data$ = data$ + CHR$(i)
'    NEXT
'NEXT
'setchars 128, 128, data$
'setchar 0, STRING$(64, CHR$(&HFF))


'd$ = getstdchars$
'FOR i = 1 TO LEN(d$) STEP &H10
'    c$ = MID$(d$, i, &H10)
'    'data$ = data$ + reverse$(c$)       ' Upside-down
'    FOR j = 1 TO LEN(c$)
'        cc$ = MID$(c$, j, 1)
'        'new$ = new$ + CHR$(ASC(cc$) AND &HAA)      ' View through screen
'        'new$ = new$ + CHR$(ASC(cc$) XOR &HFF)       ' Inverse video
'        new$ = new$ + cc$
'    NEXT
'    data$ = data$ + new$
'NEXT
'setchars 0, 255, data$
'SHELL "ascii"
'SLEEP
'SHELL "volta"

' A simple string is used instead because of QBasic's faults with TYPEs
'TYPE wchar
'    code    AS LONG             ' Unicode scalar code point
'    slot    AS INTEGER          ' DOS slot
'END TYPE
'

SUB die (s$)
PRINT s$
END
END SUB

FUNCTION forlater$ (wchar$)
' Return UTF8 encoding of the Unicode character wchar$ for storage in a file
' or places which can be decoded just in time.
'forlater$ = scalar2utf$(getcode(wchar$))
forlater$ = scalar2utf$(slots(ASC(wchar$)))
END FUNCTION

FUNCTION fornow$ (wchar$)
' Return a representation of WCHAR$ suitable for immediate printing to screen
' (obsolete, now just use PRINT wchar$)
fornow$ = wchar$
EXIT FUNCTION

IF MID$(wchar$, 1, 2) <> "U+" THEN
    fornow$ = CHR$(&HFF)
END IF
first$ = MID$(wchar$, LEN(wchar$) - 1, 1)
second$ = RIGHT$(wchar$, 1)

IF (second$ = CHR$(0)) THEN
    fornow$ = first$
    EXIT FUNCTION
ELSE
    fornow$ = first$ + second$
END IF
'fornow$ = RIGHT$(wchar$, 1)
'fornow$ = CHR$(VAL(MID$(wchar$, 1, INSTR(wchar$, ",") - 1)))
END FUNCTION

FUNCTION getcode (wchar$)
getcode = slots(ASC(wchar$))
'IF MID$(wchar$, 1, 2) <> "U+" THEN
'    getcode = -1
'END IF
'getcode = VAL(MID$(wchar$, INSTR(wchar$, ",") + 1))
'getcode = VAL("&H" + MID$(wchar$, 3))
END FUNCTION

FUNCTION getstdchars$
' Standard character data is usually at C000:272E. Maybe not.
'IF max > 256 THEN max = 256
'max = 256
'DEF SEG = &HC000
'FOR i = &H272E TO (max * &H10) + &H272E    ' &H10 bytes/character
'    data$ = data$ + CHR$(PEEK(i))
'NEXT
'DEF SEG
'getstdchars$ = data$
END FUNCTION

FUNCTION LNOT (c)
' Logical not; that is, never bitwise
IF c = 0 THEN
    LNOT = 1
ELSE
    LNOT = 0
END IF
END FUNCTION

FUNCTION loadedat (index)
' Find where Unicode character INDEX is loaded at
FOR i = 0 TO 255
    IF slots(i) = index THEN
        loadedat = i
        EXIT FUNCTION
    END IF
NEXT
loadedat = -1
END FUNCTION

FUNCTION newchar (data$)
' Allocate an unused slot for a new arbitrary character. Returns new slot #.
' DATA$ is bit-mapped data of the graphic image of the new character you want.
FOR i = 0 TO UBOUND(slots)
    slot = slots(i)
    IF (slot = -1) THEN     ' Free for us to use
        slots(i) = 0        ' But not for us to use again (uchar will
        setchar i, data$    '                              set this later).
        ' The reason why newchar() and uchar() return an ordinal instead
        ' of a one-byte character string:
        '
        '   If newchar()/uchar() returned a one-byte character string,
        '   users of this module might think they can do anything they want
        '   with the string -- including writing it to a file for later use.
        '   Wrong. You can only print the CHR$(slot) to the screen - never
        '   save it to a file. To save Unicode characters to a file, use
        '   scalar2utf() on the Unicode index.
        newchar = i
        EXIT FUNCTION
    END IF
NEXT
' No empty, set first few to empty and call again
setavailable
newchar = newchar(data$)
'die "Ran out of empty slots! TODO: Write code to free LRU"
END FUNCTION

FUNCTION reverse$ (s$)
FOR i = 1 TO LEN(s$)
    c$ = MID$(s$, i, 1)
    ret$ = c$ + ret$
NEXT
reverse$ = ret$
END FUNCTION

FUNCTION scalar2utf$ (c)
' Convert a scalar Unicode character value (C) to UTF-8
'
' Table 3-1. UTF-8 Bit Distribution (from unicode.org/unicode/uni2book/ch03.pdf)
' Scalar Value                  B1         B2         B3         B4
' 0000 0000 0xxx xxxx           0xxx xxxx
' 0000 0yyy yxxx xxxx           110y yyyy  10xx xxxx
' zzzz yyyy yyxx xxxx           1110 zzzz  10yy yyyy  10xx xxxx
' uuuu uzzz zyyy yyyx xxxx      1111 0uuu  10uu zzzz  10yy yyyy  10xx xxxx
'
IF (LNOT(c AND &HFF80)) THEN        ' Check for 0000 0000 0xxx xxxx
    utf$ = CHR$(c)
ELSEIF (LNOT(c AND &HF800)) THEN    ' Check for 0000 0yyy yxxx xxxx
    b1 = shr(c, 7)                  ' Extract y by shifting out x's
    utf$ = CHR$(&HC0 + b1)          ' Put into 110y yyyy format
    b2 = c AND &H7F                 ' Extract x
    utf$ = utf$ + CHR$(&H80 + b2)   ' Put into 10xx xxxx format
ELSE
    ' TODO: implement last two character ranges
    die ("Unhandled scalar: " + STR$(c))
END IF
scalar2utf$ = utf$
END FUNCTION

SUB setavailable
' Make all control characters except NUL available for use (\0 appears in
' places on the screen you might not expect -- at the end of strings which
' where internally stored as ASCIIZ on the screen, for example).
FOR i = 1 TO &H1F
    slots(i) = -1
NEXT
slots(7) = 0        ' Except for beep,
slots(8) = 0        ' BS,
slots(9) = 0        ' HT,
slots(10) = 0       ' LF,
slots(11) = 0       ' VT,
slots(12) = 0       ' NP,
slots(13) = 0       ' CR,
slots(127) = -1     ' Delete
FOR i = 128 TO 175  ' Accented characters
    slots(i) = -1
NEXT
FOR i = 224 TO 254  ' Greek characters and the rest
    slots(i) = -1
NEXT
END SUB

SUB setchar (ch, data$)
setchars ch, 1, data$
END SUB

SUB setchar.failed
' Based on video.src from crt21a.zip library
'c$ = c$ + CHR$(&H50) + CHR$(&H53) + CHR$(&H51)  ' push ax bx cx
'c$ = c$ + CHR$(&H52) + CHR$(&H6)                ' push dx es
'c$ = c$ + CHR$(&HB3) + CHR$(&H0)                ' mov bl, 0
'c$ = c$ + CHR$(&HB9) + CHR$(&H8) + CHR$(&H0)    ' mov cx, 0008
'c$ = c$ + CHR$(&HB2) + CHR$(&H8)                ' mov dl, 8
'c$ = c$ + CHR$(&H55)                            ' push bp
'c$ = c$ + CHR$(&HB8) + MKI$(VARSEG(data$))      ' mov ax, varseg(data$)
'c$ = c$ + CHR$(&H8E) + CHR$(&HC0)               ' mov es, ax
'c$ = c$ + CHR$(&HBD) + MKI$(sadd(data$))        ' mov bp, varptr(data$)
'c$ = c$ + CHR$(&HB8) + CHR$(&H21) + CHR$(&H11)  ' mov ax, 1121
'c$ = c$ + CHR$(&HCD) + CHR$(&H10)               ' int 10
'c$ = c$ + CHR$(&H5D) + CHR$(&H7) + CHR$(&H5A)   ' pop bp es dx
'c$ = c$ + CHR$(&H59) + CHR$(&H5B) + CHR$(&H58)  ' pop ax bx cx
'c$ = c$ + CHR$(&HCB)                            ' retf
' My own failing code
'c$ = c$ + CHR$(&H50) + CHR$(&H53) + CHR$(&H51)  ' push ax bx cx
'c$ = c$ + CHR$(&H52) + CHR$(&H55) + CHR$(&H6)   ' push dx bp es
'c$ = c$ + CHR$(&HB4) + CHR$(&H11)           ' mov ah, 11   ; chargen routine
'c$ = c$ + CHR$(&HB0) + CHR$(&H0)            ' mov al, 0    ; user char load
'c$ = c$ + CHR$(&HB7) + CHR$(LEN(data$))     ' mov bh, len(); bytes/character
'c$ = c$ + CHR$(&HB3) + CHR$(&H0)            ' mov bl, 0    ; block to load
'c$ = c$ + CHR$(&HB9) + CHR$(&H1) + CHR$(&H0)' mov cx, 0001 ; number of chars
'c$ = c$ + CHR$(&HBA) + MKI$(ASC(c$))        ' mov dx, ch.. ; char to set
'c$ = c$ + CHR$(&HBD) + MKI$(VARPTR(data$))  ' mov bp, dat..; character data
'c$ = c$ + CHR$(&HCD) + CHR$(&H10)           ' int 10       ; BIOS video int
'c$ = c$ + CHR$(&H7) + CHR$(&H5D) + CHR$(&H5A)   ' pop es bp dx
'c$ = c$ + CHR$(&H59) + CHR$(&H5B) + CHR$(&H58)  ' pop cx bx ax
'c$ = c$ + CHR$(&HCB)                           ' retf
' Blanks out all characters.
'c$ = ""
'c$ = c$ + CHR$(&H50) + CHR$(&H53) + CHR$(&H51)  ' push ax bx cx
'c$ = c$ + CHR$(&H52) + CHR$(&H6)                ' push dx es
'c$ = c$ + CHR$(&HB3) + CHR$(&H0)                ' mov bl, 0
'c$ = c$ + CHR$(&HB9) + CHR$(&H8) + CHR$(&H0)    ' mov cx, 0008
'c$ = c$ + CHR$(&H55)                            ' push bp
'c$ = c$ + CHR$(&HB8) + MKI$(VARSEG(data$))      ' mov ax, VARSEG(data$)
'c$ = c$ + CHR$(&H8E) + CHR$(&HC0)               ' mov es, ax
'c$ = c$ + CHR$(&HBD) + MKI$(VARPTR(data$))      ' mov bp, VARPTR(data$)
'c$ = c$ + CHR$(&HB8) + CHR$(&H0) + CHR$(&H11)   ' mov ax, 1100 (1102=small)
'c$ = c$ + CHR$(&HCD) + CHR$(&H10)               ' int 10       (1100=userset)
'c$ = c$ + CHR$(&H5D) + CHR$(&H7) + CHR$(&H5A)   ' pop bp es dx
'c$ = c$ + CHR$(&H59) + CHR$(&H5B) + CHR$(&H58)  ' pop cx bx ax

END SUB

SUB setchars (ch, count, data$)
c$ = ""
'FOR i = 1 TO 64
'   data$ = data$ + CHR$(i)     ' makes a figure looking like a cent sign
'NEXT
c$ = c$ + CHR$(&H50) + CHR$(&H53) + CHR$(&H51)  ' push ax bx cx
c$ = c$ + CHR$(&H52) + CHR$(&H6)                ' push dx es
c$ = c$ + CHR$(&HB7) + CHR$(&H10)               ' mov bh, 10
c$ = c$ + CHR$(&HB3) + CHR$(&H0)                ' mov bl, 0
c$ = c$ + CHR$(&HB9) + MKI$(count)              ' mov cx, COUNT
c$ = c$ + CHR$(&HBA) + MKI$(ch)                 ' mov dx, CH
c$ = c$ + CHR$(&HB8) + CHR$(&H0) + CHR$(&H11)   ' mov ax, 1100
c$ = c$ + CHR$(&H55) + CHR$(&H50)               ' push bp ax
c$ = c$ + CHR$(&HB8) + MKI$(VARSEG(data$))      ' mov ax, VARSEG(data$)
c$ = c$ + CHR$(&H8E) + CHR$(&HC0)               ' mov es, ax
c$ = c$ + CHR$(&HBD) + MKI$(SADD(data$))        ' mov bp, SADD(data$)
c$ = c$ + CHR$(&H58)                            ' pop ax
c$ = c$ + CHR$(&HCD) + CHR$(&H10)               ' int 10
c$ = c$ + CHR$(&H5D) + CHR$(&H7) + CHR$(&H5A)   ' pop bp es dx
c$ = c$ + CHR$(&H59) + CHR$(&H5B) + CHR$(&H58)  ' pop cx bx ax
c$ = c$ + CHR$(&HCB)                            ' retf

DEF SEG = VARSEG(c$)
SCREEN 0
CALL Absolute(SADD(c$))
DEF SEG
END SUB

FUNCTION shl (num, bits)
shl = INT(num * (2 ^ bits))
END FUNCTION

FUNCTION shr (num, bits)
shr = INT(num / (2 ^ bits))
END FUNCTION

FUNCTION tobin$ (n)
' convert an integer value into a binary string, e.g 4 becomes "100"
' nm is the value to convert.
sa$ = ""
'n = nm: ' needed because despite what Help says, num will be changed :(
   WHILE n > 0
      bit = n MOD 2
      n = INT(n / 2)
      a$ = RIGHT$(STR$(bit), 1) + a$
   WEND
tobin$ = a$
END FUNCTION

FUNCTION todec (b$)
FOR k = LEN(b$) TO 1 STEP -1
    IF MID$(b$, k, 1) = "1" THEN d = d + (2 ^ (LEN(b$) - k))
NEXT
todec = d
END FUNCTION

FUNCTION uchar$ (index)
' Load a new Unicode character at code point INDEX in font FONT$ into the
' screen. Returns a one or two byte string describing where the Unicode is
' stored in the BIOS character slots. Can be immediately printed, but to
' print to file forlater$(wchar$) is needed.
'
'   index   - Unicode character code in hex     (FOR SAVING CHAR TO FILES)
'   slota$  - Slot glyph is assigned to         (FOR SCREEN ONLY)
'   slotb$  - Slot glyph is assigned to #2, null if none (fullwidth chars only)
'
' To save a Unicode character to a file, print scalar2utf$(getcode(wchar$))
' to a file. It can then be decoded via utf2scalar(data.from.file$)
'
' To print to screen, use FORNOW$(). Before printing to file use FORLATER$().
'
' If you don't want to specify FONT$ all the time, use uchar$(index).

' If index is negative, probably specified &HFFFF instead of &HFFFF&.
IF index < 0 THEN
    die "Index negative:" + STR$(index)
    index = (-index) + &H10000
END IF

' Already loaded?
slot = loadedat(index)
IF (slot <> -1) THEN
'    uchar$ = "U+" + HEX$(index) + CHR$(slot)       ' Reuse existing
    ' If next slot has same index, then this is a two-byte Unicode glyph
    IF (slots(slot + 1) = index) THEN
        uchar$ = CHR$(slot) + CHR$(slot + 1)
    ELSE
        uchar$ = CHR$(slot)
    END IF
    EXIT FUNCTION
END IF

SEEK #fontfile, (index * 32) + 1
data$ = INPUT$(32, #fontfile)
IF (LEN(data$) <> 32) THEN
    die "Glyph not in file: " + HEX$(index)
END IF

data1$ = MID$(data$, 1, 16)     ' Only correct if data2$ not all nulls
data2$ = MID$(data$, 16)        ' If nonnulls, have to uninterleave first

' Second glyph is optional, only load it if nonzero
IF index = 2 THEN
    'STOP
END IF
IF data2$ = STRING$(17, 0) OR LEN(data2$) = 0 THEN      ' Half-width 8x16
    slot2 = 0                                           ' (no interleave)
    slot = newchar(MID$(data$, 1, 16))
    slots(slot) = index         ' For loadedat(), getcode()
    uchar$ = CHR$(slot)
    EXIT FUNCTION
ELSE                                                    ' Full-width 16x16
    ' Uninterleave data.                                ' (interleaved)
    data1$ = ""
    data2$ = ""
    FOR i = 1 TO LEN(data$) STEP 2
        data1$ = data1$ + MID$(data$, i, 1)
        data2$ = data2$ + MID$(data$, i + 1, 1)
    NEXT
    slot = newchar(data1$)
    slot2 = newchar(data2$)
    slots(slot2) = index
    uchar$ = CHR$(slot) + CHR$(slot2)
END IF

'ucharf$ = LTRIM$(STR$(slot)) + "," + LTRIM$(STR$(index)
'uchar$ = "U+" + HEX$(index) + CHR$(slot) + CHR$(slot2)

END FUNCTION

FUNCTION ucharf$ (index, font$)
' (USES 16-BIT FILE FORMAT, which is editable with FontEdit but incompatible
' with Unifont.bin)
'
' Load a new Unicode character at code point INDEX in font FONT$ into the
' screen. Returns "slot,index" which can be accessed by using getslot() and
' getcode(). These mean:
'
'   index   - Unicode character code            (FOR SAVING CHAR TO FILES)
'   slot    - Usable with CHR$() to print glyph (FOR SCREEN ONLY)
'
' To save a Unicode character to a file, print scalar2utf$(getcode(wchar$))
' to a file. It can then be decoded via utf2scalar(data.from.file$)
'
' If you don't want to specify FONT$ all the time. use uchar$(index).

' Already loaded?
slot = loadedat(index)
IF (slot <> -1) THEN
    'ucharf$ = "U+" + HEX$(index) + CHR$(slot)       ' Reuse existing
    ucharf$ = CHR$(slot)
END IF

' Find which block font is in, and where in that block it is
block = INT(index / &H100)
position = index MOD &H100

block$ = LTRIM$(HEX$(block))
block$ = block$ + STRING$(4 - LEN(block$), "0")
f = FREEFILE
OPEN "D:\th\u\fonts\128bit\" + font$ + "\" + block$ + ".fnt" FOR INPUT AS #f
SEEK #f, (position * 16) + 1
data$ = INPUT$(16, #f)
CLOSE f

slot = newchar(data$)

' Record our ordinal in SLOTS() array so loadedat() can look it up
slots(slot) = index

'ucharf$ = LTRIM$(STR$(slot)) + "," + LTRIM$(STR$(index))
ucharf$ = "U+" + HEX$(index) + CHR$(slot)
END FUNCTION

FUNCTION unutf$ (s$)
' Decode a UTF-8 string while loading any Unicode character encountered
' Good for loading Unicode text from a file

' Table 3-1. UTF-8 Bit Distribution (from unicode.org/unicode/uni2book/ch03.pdf)
' Scalar Value                  B1         B2         B3         B4
' 0000 0000 0xxx xxxx           0xxx xxxx
' 0000 0yyy yxxx xxxx           110y yyyy  10xx xxxx
' zzzz yyyy yyxx xxxx           1110 zzzz  10yy yyyy  10xx xxxx
' uuuu uzzz zyyy yyyx xxxx      1111 0uuu  10uu zzzz  10yy yyyy  10xx xxxx
' and so on

ret$ = ""
i = 1
DO WHILE i <= LEN(s$)
    byte = ASC(MID$(s$, i, 1))
    IF (byte <= &H7F) THEN
        ret$ = ret$ + CHR$(byte)
    ELSEIF (byte >= &HC0 AND byte < &HE0) THEN   ' two-byte char
        ' 110y-yyyy  10xx-xxxx
        byte = shr(byte - &HC0, 6)   ' Move over near MSB
        i = i + 1
        byte = byte + ASC(MID$(s$, i, 1))
        ret$ = ret$ + uchar$(byte)
    ELSEIF (byte >= &HE0 AND byte < &HF0) THEN   ' three-byte char
        ' 1110-zzzz 10yy-zzzz 10xx-xxxx
                   byte = shr(byte - &HE0, 21)
        i = i + 1: byte = byte + shr(ASC(MID$(s$, i, 1)), 14)
        i = i + 1: byte = byte + ASC(MID$(s$, i, 1))
        ret$ = ret$ + uchar$(byte)
    ELSE
        die "unutf: not implemented"
    END IF
    i = i + 1

LOOP
unutf$ = ret$
END FUNCTION

FUNCTION utf2scalar (utf$)
' Convert one UTF-8 sequence into it's scalar value
'
' Obsolete in favor of UNUTF$()
'
' Table 3-1. UTF-8 Bit Distribution (from unicode.org/unicode/uni2book/ch03.pdf)
' Scalar Value                  B1         B2         B3         B4
' 0000 0000 0xxx xxxx           0xxx xxxx
' 0000 0yyy yxxx xxxx           110y yyyy  10xx xxxx
' zzzz yyyy yyxx xxxx           1110 zzzz  10yy yyyy  10xx xxxx
' uuuu uzzz zyyy yyyx xxxx      1111 0uuu  10uu zzzz  10yy yyyy  10xx xxxx
' and so on
l = LEN(utf$)
IF l >= 1 THEN b1 = ASC(MID$(utf$, 1, 1))
IF l >= 2 THEN b2 = ASC(MID$(utf$, 2, 1))
IF l >= 3 THEN b3 = ASC(MID$(utf$, 3, 1))
IF l >= 4 THEN b4 = ASC(MID$(utf$, 4, 1))
IF l >= 5 THEN
    die "UTF-8 sequence too long. Is it multiple sequences?"
END IF
IF b1 < &H7F THEN          ' single byte of ASCII
    IF l <> 1 THEN die "wrong lengthened UTF-8 ASCII byte"
    c = b1
ELSEIF b1 AND &HC0 THEN     ' 110y yyyy sequence
    'y yyyy | 10xx xxxx -> 0000 0yyy yxxx xxxx
    y = b1 - &HC0           ' remove 110x-xxxx prefix
    y = y * &H80            ' Move y into 0yyy yxxx xxxx
    IF (b2 AND &HC0) <> &H80 THEN     ' Check for 10xx-xxxx prefix
        ' A 110y-yyyy sequence was followed by a non 10xx-xxxx byte. Invalid,
        ' so use Invalid Termination Character and treat b2 as a sep. char.
        utf2scalar = &HFFFD
        EXIT FUNCTION
        
        ' Problem: Can functions return arrays? Need to return more than
        ' one character here, but cannot! I'm not going to use strings.
        'utf2scalar = utf2scalar(b2)
    END IF
    x = b2 AND &H3F         ' Extract x
    c = y + x
ELSE
    die "utf8->scalar for character " + STR$(c) + " not implemented"
END IF
utf2scalar = c
END FUNCTION

SUB volta
SHELL "volta"
END SUB

